/******************************************************************************** 
Desarrollado por:   Globant de México
Autor:              Roberto Carlos Avendaño Quintana
Proyecto:           TOYOTA TAM
Descripción:        Clase que contiene la logica para el funcionamiento de las solicitudes de excepciónes
******************************************************************************* */

public without sharing class SolicitudExcepcionIncentivos {
    
    //Metodo utilizado para guardar la solicitudes de excepción de tipo 'Flotilla-Retail'
    @AuraEnabled
    public static void guardaSolicitudExcepcion(TAM_WrpSolicitudFlotillaProgramaModelos wrapSolicitud,String motivoSolicitud,
                                                String comentario, Decimal precioSolicitado, boolean incentivoManual,
                                                String politicaSeleccionada,Decimal incentivoTotalManual,Decimal incentivoDealerManual, 
                                                Decimal incentivoTMEXManual,String incentivoFechaCierre, String codigoDelaer,
                                                String listaVINESIn,String fechaVenta,Boolean esFlotRetail,String documentId){
                                                    
        List<string> listaVIN = listaVINESIn.Split(','); 
        Account acct = new Account();
        List<String> vinesList = new List<String>();
        List<String> datosVIN;
        
        system.debug('fecha venta'+fechaVenta);
                                                    
        system.debug('motivo In'+motivoSolicitud);                                           
        List<String> fechaVentaLs = fechaVenta.split(' ');
        String auxFecha = fechaVentaLs[0];
		List<string> fechaFormat = auxFecha.split('-');

		date fechaVentaVIN = date.parse(fechaFormat[2]+'/'+fechaFormat[1]+'/'+fechaFormat[0]);                                           
        
        
        if(!listaVIN.isEmpty()){
            for(String i : listaVIN){
                System.debug('EN guardaSolicitudExcepcion VINinit: ' + i);   
            } 
        }
        
        Id recordTypeId =  Schema.SObjectType.TAM_SolicitudExpecionIncentivo__c.getRecordTypeInfosByDeveloperName().get('ExcepcionVentaCorporativa').getRecordTypeId();
        Integer numeroVINES = wrapSolicitud.lVinesSeleccionados.size();
        String  listaVINES =  wrapSolicitud.lVinesSeleccionados.toString();
        String  folioSolicitudVenta = wrapSolicitud.strFolioSolicitd;
        String  nombreCliente =  wrapSolicitud.strNombreCliente;
        String  rangoPrograma =  wrapSolicitud.strRangoPrograma;
        String  fechaVigenciaCliente = wrapSolicitud.strFechaVigencia;
        String  idExterno  = wrapSolicitud.lModelosSeleccionados[0].strIdExterno;
        system.debug('precio fecha cierre'+incentivoFechaCierre);                                      
        system.debug('incentivo fecha cierre'+incentivoFechaCierre);
        String politicaFechaCierre = incentivoFechaCierre;
        String  tipoVentaIn;
        datosVIN = wrapSolicitud.lModelosSeleccionados[0].strNombre.split('-');
        String serie = datosVIN[0];
        String codigoModelo = datosVIN[1];
        String anioModelo = datosVIN[2];
        
        if(!wrapSolicitud.lVinesSeleccionados.isEmpty()){      
            for(TAM_WrpSolicitudFlotillaProgramaModelos.wrpVinesExcepcion i : wrapSolicitud.lVinesSeleccionados){
                vinesList.add(i.strVin);
                
            }
        }
        
        
        if(wrapSolicitud.lModelosSeleccionados[0].strTipoVenta == 'Financiamiento TFS'){
            tipoVentaIn = 'Con TFS';
            
        }else{
            tipoVentaIn = 'Sin TFS';
            
        }
        decimal incentivoCorrspTMEXCash ;
        decimal incentivoSeleccTMEXCash ;
        
        
        //Conversion de política correspondiente a pesos
        if(politicaFechaCierre != null){
            TAM_DetallePoliticaJunction__c politicaCorrespondiente = [Select id,TAM_IncPropuesto_Cash__c,TAM_IncPropuesto_Porcentaje__c,TAM_IncDealer_Cash__c,
                                                                      TAM_IncDealer_Porcentaje__c,
                                                                      TAM_IncentivoTMEX_Cash__c,TAM_IncentivoTMEX_Porcentaje__c FROM TAM_DetallePoliticaJunction__c WHERE id =: politicaFechaCierre];
            
            if(politicaCorrespondiente.TAM_IncPropuesto_Porcentaje__c != null && politicaCorrespondiente.TAM_IncPropuesto_Cash__c == null){
                incentivoCorrspTMEXCash = politicaCorrespondiente.TAM_IncentivoTMEX_Porcentaje__c * precioSolicitado / 100 ;
                
            }
            if(politicaCorrespondiente.TAM_IncPropuesto_Porcentaje__c == null && politicaCorrespondiente.TAM_IncPropuesto_Cash__c != null){
                incentivoCorrspTMEXCash = politicaCorrespondiente.TAM_IncentivoTMEX_Cash__c ;
                
            }

            System.debug('incentivo correspondiente flotilla'+incentivoCorrspTMEXCash);
            
        }
        
        //Conversión de política seleccionada
        if(politicaSeleccionada != null){
            TAM_DetallePoliticaJunction__c politicaCorrespondiente = [Select id,TAM_IncPropuesto_Cash__c,TAM_IncPropuesto_Porcentaje__c,TAM_IncDealer_Cash__c,
                                                                      TAM_IncDealer_Porcentaje__c,
                                                                      TAM_IncentivoTMEX_Cash__c,TAM_IncentivoTMEX_Porcentaje__c FROM TAM_DetallePoliticaJunction__c WHERE id =: politicaSeleccionada];
            
            if(politicaCorrespondiente.TAM_IncPropuesto_Porcentaje__c != null && politicaCorrespondiente.TAM_IncPropuesto_Cash__c == null){
                incentivoSeleccTMEXCash = politicaCorrespondiente.TAM_IncentivoTMEX_Porcentaje__c * precioSolicitado / 100 ;
                
            }
            if(politicaCorrespondiente.TAM_IncPropuesto_Porcentaje__c == null && politicaCorrespondiente.TAM_IncPropuesto_Cash__c != null){
                incentivoSeleccTMEXCash = politicaCorrespondiente.TAM_IncentivoTMEX_Cash__c ;
                
            }
            
            System.debug('incentivo seleccionado retail'+incentivoSeleccTMEXCash);
        }
        
        // Incentivo Manual
        if(politicaSeleccionada == null && incentivoManual == true ){
            incentivoSeleccTMEXCash = incentivoTMEXManual * precioSolicitado / 100 ;
            
        }
        
        Id recordTypeIdAcc =  Schema.SObjectType.Account.getRecordTypeInfosByDeveloperName().get('Dealer').getRecordTypeId();        
        if(recordTypeIdAcc != null){
            acct = [Select id FROM Account WHERE Codigo_Distribuidor__c =: codigoDelaer AND recordtypeId =: recordTypeIdAcc limit 1];
        }
                                                    
                                                    
        //Se revisa si la escepción aplica para aprobación automatica
        Boolean aprobAutomatica;
        if(incentivoSeleccTMEXCash <= incentivoCorrspTMEXCash){
        	aprobAutomatica = true;
        }else if(incentivoSeleccTMEXCash > incentivoCorrspTMEXCash){
            aprobAutomatica = false;
        }
                                                                                              
        //Se crea un solicitud por cad VIN
        List<TAM_SolicitudExpecionIncentivo__c> listSolExp = new  List<TAM_SolicitudExpecionIncentivo__c>();
        
        for(String i : listaVIN){
            TAM_SolicitudExpecionIncentivo__c solicitudExcepcionFleet = new TAM_SolicitudExpecionIncentivo__c();
            solicitudExcepcionFleet.TAMVIN__c = i;
            solicitudExcepcionFleet.TAM_excepcionFlotillaRetail__c = true;
            solicitudExcepcionFleet.TAM_SubmittedDate__c = fechaVentaVIN;
            //No se necesita autorizacion
            if(aprobAutomatica == true){
            	solicitudExcepcionFleet.TAM_AprobacionDM__c = 'Aprobado';
                solicitudExcepcionFleet.TAM_VoBo_Aprobacio__c = 'Aprobado';
                solicitudExcepcionFleet.TAM_AprobacionFinanzas__c = 'Aprobado';
                solicitudExcepcionFleet.TAM_Fecha_Autorizacion_DM__c = Date.today();
                solicitudExcepcionFleet.TAM_AprobacionAutomatica__c = true;
            }
            //Se necesita autorizacion
            if(aprobAutomatica == false){
                solicitudExcepcionFleet.TAM_AprobacionDM__c = 'Aprobado';
                solicitudExcepcionFleet.TAM_VoBo_Aprobacio__c = 'Pendiente';
                solicitudExcepcionFleet.TAM_AprobacionFinanzas__c = 'Pendiente';   
                solicitudExcepcionFleet.TAM_AprobacionAutomatica__c = false;
            }
            solicitudExcepcionFleet.TAM_Distribuidor__c = acct.id;
            solicitudExcepcionFleet.TAM_NumeroVINES__c = numeroVINES;
            solicitudExcepcionFleet.RecordTypeId = recordTypeId;
            solicitudExcepcionFleet.TAM_listaVINES__c = vinesList.toString();
            solicitudExcepcionFleet.TAM_FolioVentaCorporativa__c  = folioSolicitudVenta;
            solicitudExcepcionFleet.TAM_NombreCliente__c  = nombreCliente;
            solicitudExcepcionFleet.TAM_RangoPrograma__c = rangoPrograma ;
            solicitudExcepcionFleet.TAM_FechaVigenciaCliente__c = fechaVigenciaCliente;
            solicitudExcepcionFleet.TAM_IDExterno__c = idExterno+I;
            solicitudExcepcionFleet.TAM_TipoVenta__c = tipoVentaIn;
            solicitudExcepcionFleet.TAM_Serie__c = serie;
            solicitudExcepcionFleet.TAM_Modelo__c = codigoModelo;
            solicitudExcepcionFleet.TAM_AnioModelo__c = anioModelo;
            solicitudExcepcionFleet.TAM_MotivoSolicitudFlotilla__c = motivoSolicitud;
            solicitudExcepcionFleet.TAM_Comentario__c = comentario;
            solicitudExcepcionFleet.TAM_PrecioSolicitadoDealer__c = precioSolicitado;
            solicitudExcepcionFleet.TAM_IncentivoManual__c = incentivoManual;
            solicitudExcepcionFleet.TAM_IncentivoCorrespondienteRetail__c = politicaFechaCierre;
            solicitudExcepcionFleet.TAM_IncCorrespCashTMEX__c = incentivoCorrspTMEXCash;
            solicitudExcepcionFleet.TAM_IncSeleccCashTMEX__c = incentivoSeleccTMEXCash;
            if(incentivoManual == true){
                solicitudExcepcionFleet.TAM_TotalIncentivoManual__c = incentivoTotalManual;
                solicitudExcepcionFleet.TAM_TotalIncentivoDealerManual__c = incentivoDealerManual;
                solicitudExcepcionFleet.TAM_TotalIncentivoTMEXManual__c = incentivoTMEXManual; 
                solicitudExcepcionFleet.TAM_PoliticaSeleccionadaRetail__c = null;
                
            }
            if(incentivoManual == false)
                system.debug('entro aquiii'+politicaSeleccionada);
                solicitudExcepcionFleet.TAM_PoliticaSeleccionadaRetail__c = politicaSeleccionada;
            
            listSolExp.add(solicitudExcepcionFleet);
        }
        
        try{  
            System.debug('EN guardaSolicitudExcepcion listSolExp: ' + listSolExp);        	
            List<Database.UpsertResult> dtUpsrv = Database.upsert(listSolExp, TAM_SolicitudExpecionIncentivo__c.TAM_IDExterno__c, false);	
            Set<String> solicitudesCreadas = new Set<String>();			
            for (Database.UpsertResult objDtSvr : dtUpsrv){
                if(!objDtSvr.isSuccess())
                    System.debug('EN guardaSolicitudExcepcion Error a la hora de crear los reg en TAM_SolicitudExpecionIncentivo: ' + objDtSvr.getErrors()[0].getMessage());
                if(objDtSvr.isSuccess())
                    System.debug('EN guardaSolicitudExcepcion los datos del reg se actualizaron con exito ID: ' + objDtSvr.getId());
                    solicitudesCreadas.add(objDtSvr.getId());										
            }
             //Metodo que relaciona las solicitudes creadas con el documento adjunto
             List<String> listaSolicitudesCreadas =new List<String>();
             listaSolicitudesCreadas.addAll(solicitudesCreadas);
             if(documentId != null){
                 relatedDocumentWithException(listaSolicitudesCreadas,documentId);   
             }  
        }catch(Exception e){
            system.debug('Error en el proceso'+e.getMessage());     
            
        }
        
        
    }
    
    //Metodo para obtener la politica correspondiente de tipo (Venta Corporativa)
    @AuraEnabled
    public static  SolicitudExcepcionIncentivosFlotilla.wrapResumenPrecio getPoliticaFechaCierre(String modelo, String anioModelo,String rangoPrograma,String tipoVenta, String fechaVenta){
        Boolean tipoVentaBoolean;
        Date fechaDeVenta = Date.valueOf(fechaVenta);
        Date fechaVentaMenoDosMeses = fechaDeVenta.addDays(-90);
        List<TAM_DetallePoliticaJunction__c> detallePoliticaInc = new List<TAM_DetallePoliticaJunction__c>();
        TAM_DetallePoliticaJunction__c politicaCorrespondiente = new TAM_DetallePoliticaJunction__c();
        
        if(tipoVenta == 'TFS'){
            tipoVentaBoolean = true; 
        }
        
        if(tipoVenta == 'SIN TFS'){
            tipoVentaBoolean = false;
        }
        
        
        TAM_DetallePoliticaJunction__c politicaMenorValor = new TAM_DetallePoliticaJunction__c();
        detallePoliticaInc = [SELECT TAM_BonoLealtadDealer__c,TAM_PoliticaIncentivos__r.TAM_FinVigencia__c,TAM_BonoLealtadTMEX__c,TAM_Pago_TFS__c,TAM_PoliticaIncentivos__R.Name,TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c,TAM_BonoLealtad__c,name,TAM_IncentivoTMEX_Cash__c,TAM_IncPropuesto_Cash__c,TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c,
                              id,TAM_AnioModelo__c,TAM_Clave__c,TAM_IncDealer_Cash__c,TAM_MSRP__c FROM TAM_DetallePoliticaJunction__c 
                              WHERE TAM_Rango__r.name =: rangoPrograma AND TAM_PoliticaIncentivos__R.recordtype.name = 'Venta Corporativa' AND TAM_PoliticaIncentivos__R.TAM_InicioVigencia__c <=: fechaDeVenta AND TAM_PoliticaIncentivos__R.TAM_FinVigencia__c >=: fechaDeVenta AND TAM_Clave__c =: modelo AND TAM_AnioModelo__c =: anioModelo AND (TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vigente' or TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vencida')  order by TAM_IncPropuesto_Cash__c asc];
        
        
        Decimal maxvalue ;
        if(detallePoliticaInc.size() > 0){
            maxvalue = detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;   
        }
        
        //Se calcula cual es la política con menor valor
        if(!detallePoliticaInc.isEmpty()){
            For (TAM_DetallePoliticaJunction__c i : detallePoliticaInc)
            {
                
                if(i.TAM_IncPropuesto_Cash__c < maxvalue)
                    maxvalue = i.TAM_IncPropuesto_Cash__c;   
                politicaMenorValor = i;
                break;
            } 
        }
        
        system.debug('incentivo correspodneinte flotilla'+politicaMenorValor);
        
        //Se manda a llamar a metodo para crear un objeto wrapper y retornalo
        SolicitudExcepcionIncentivosFlotilla.wrapResumenPrecio warapObjCalculo = new SolicitudExcepcionIncentivosFlotilla.wrapResumenPrecio();
        
        warapObjCalculo =  SolicitudExcepcionIncentivosFlotilla.calculoTotal(politicaMenorValor.id,politicaMenorValor.TAM_MSRP__c);

        if(politicaMenorValor != null){
            return warapObjCalculo;
        }else{
            return null;
        }
        
    }  
    
    
    
    @AuraEnabled
    public static List<wrapResumenPrecio> RetailFlot(String modelo, String anioModelo,String fechaVentaIN,String solicitaBono,String tipoVenta){
        
        boolean pagoTFS; 
        if(tipoVenta == 'TFS'){ 
            pagoTFS = true;
        }
        if(tipoVenta == 'SINTFS'){
            pagoTFS = false; 
        }
        
        
        List<String> fechaVentaLs = fechaVentaIn.split(' ');
        String auxFecha = fechaVentaLs[0]; 
		List<string> fechaFormat = auxFecha.split('-');

		date fechaVentaVIN = date.parse(fechaFormat[2]+'/'+fechaFormat[1]+'/'+fechaFormat[0]);
        
        system.debug('fecha de cierre'+fechaVentaVIN);
        
        List<PricebookEntry> precioVehiculo = new List<PricebookEntry>();
        TAM_DetallePoliticaJunction__c politicaMenorValor = new TAM_DetallePoliticaJunction__c();
        List<wrapResumenPrecio> listaIncentivos = new List<wrapResumenPrecio> ();
        TAM_DetallePoliticaJunction__c [] detallePoliticaInc;
        Pricebook2[] listaPrecio;
        integer getYear = fechaVentaVIN.year();
        integer getMonth =  fechaVentaVIN.month();
        integer getDay  = fechaVentaVIN.day();
        integer getDaysOfMonth = Date.daysInMonth(getYear,getMonth);   
        Date inicioMes = fechaVentaVIN.addDays(-getDay+1);  
        Date finMes = inicioMes.addDays(getDaysOfMonth-1); 
        String codigoProducto = modelo+anioModelo;       
        String nombreListaPrecio;
        
        Map<Integer, String> mapMes = new Map<Integer, String>();
        mapMes.put(1, 'Enero');
        mapMes.put(2, 'Febrero');
        mapMes.put(3, 'Marzo');
        mapMes.put(4, 'Abril');
        mapMes.put(5, 'Mayo');
        mapMes.put(6, 'Junio');
        mapMes.put(7, 'Julio');
        mapMes.put(8, 'Agosto');
        mapMes.put(9, 'Septiembre');
        mapMes.put(10, 'Octubre');
        mapMes.put(11, 'Noviembre');
        mapMes.put(12, 'Diciembre');
        
        Date todayDate = system.today();
        String mes = mapMes.get(getMonth);
        String nombreListaPreciosHoy = 'VH-'+mes+'-'+getYear;
        
        //Consultar el registro del detalle de la politica de incentivos a partir de ID  de registro
        detallePoliticaInc = [SELECT TAM_BonoLealtadDealer__c,TAM_BonoLealtadTMEX__c,TAM_Pago_TFS__c,TAM_PoliticaIncentivos__R.Name,TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c,TAM_BonoLealtad__c,name,TAM_IncentivoTMEX_Cash__c,TAM_IncPropuesto_Cash__c,TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c,
                              id,TAM_AnioModelo__c,TAM_Clave__c,TAM_IncDealer_Cash__c FROM TAM_DetallePoliticaJunction__c 
                              WHERE TAM_PoliticaIncentivos__R.recordtype.name = 'Retail' AND (TAM_PoliticaIncentivos__R.TAM_InicioVigencia__c <=: fechaVentaVIN AND TAM_PoliticaIncentivos__R.TAM_FinVigencia__c >=: fechaVentaVIN) AND TAM_Clave__c =: modelo AND TAM_AnioModelo__c =: anioModelo AND (TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vigente' or TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vencida')  order by TAM_IncPropuesto_Cash__c asc];
       
        system.debug('resultado de polit'+detallePoliticaInc);
        
        Decimal maxvalue ;
        if(detallePoliticaInc.size() > 0){
         maxvalue = detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;   
        }
                    
        //Se calcula cual es la política con menor valor
        if(!detallePoliticaInc.isEmpty()){
        	For (TAM_DetallePoliticaJunction__c i : detallePoliticaInc)
        {
            
            if(i.TAM_IncPropuesto_Cash__c < maxvalue)
                maxvalue = i.TAM_IncPropuesto_Cash__c;   
                politicaMenorValor = i;
                break;
        	} 
        }
        
        system.debug('menor valor'+politicaMenorValor);
        
        //Consultar lista de precios *** Actualizar por la variable nombreListaPreciosHoy*****
        listaPrecio = [Select id,name from Pricebook2 where name =: nombreListaPreciosHoy];
        
        //Consultar el precio del Vehiculo en base a la lista de precos del dia de hoy  
        if(listaPrecio.size() >0){
        	precioVehiculo = [select id,name,PrecioDealer__c,Pricebook2.Name,PrecioMayorista__c,PrecioPublico__c,Product2.ProductCode,Product2.Anio__c From PricebookEntry WHERE Pricebook2.Name != 'Standard Price Book' AND Pricebook2Id =: listaPrecio[0].id AND Product2.IdExternoProducto__c =: codigoProducto];  
        }
        system.debug('precioresultado'+precioVehiculo);

        //Si el precio no existe en la lista de precios vigente se consulta el ultimo precio vigente del VIN
        if(precioVehiculo.isEmpty() || precioVehiculo == null ){
       						 precioVehiculo = [select Pricebook2.FinVigencia__c,id,PrecioDealer__c,Pricebook2.Name,PrecioMayorista__c,PrecioPublico__c
                              ,Product2.ProductCode,Product2.Anio__c From PricebookEntry 
                              WHERE Pricebook2.Name != 'Standard Price Book' AND Product2.IdExternoProducto__c =: codigoProducto AND IsActive = true AND PrecioPublico__c != NULL order by Pricebook2.FinVigencia__c desc limit 1];  
            
        system.debug('ultimo precio'+precioVehiculo);
            
        }
        
        system.debug('size politicas'+detallePoliticaInc.size());
        if(precioVehiculo.size()> 0 && detallePoliticaInc.size() > 0){
            system.debug('entro al ifs');
            //for(TAM_DetallePoliticaJunction__c incentivo: detallePoliticaInc){
                for(PricebookEntry precioVIN : precioVehiculo){
                    system.debug('antes del primer if'+ politicaMenorValor.TAM_IncPropuesto_Cash__c);
                    if(politicaMenorValor.TAM_IncPropuesto_Cash__c != null){
                        system.debug('antes del ifs');
                        if(solicitaBono == 'SinBOno'){ 
                            system.debug('sin bono');
                            decimal precioPublico = precioVIN.PrecioPublico__c;
                            decimal precioFinal = precioPublico - politicaMenorValor.TAM_IncPropuesto_Cash__c;
                            wrapResumenPrecio resumenPrecio = new wrapResumenPrecio();
                            resumenPrecio.listaPrecioVigente = precioVIN.Pricebook2.Name;
                            resumenPrecio.nombrePolitica = politicaMenorValor.TAM_PoliticaIncentivos__R.Name;
                            resumenPrecio.precioPublico = precioVIN.PrecioPublico__c;
                            resumenPrecio.precioDealer =  precioVIN.PrecioPublico__c;
                            resumenPrecio.incentivoSeleccionado = politicaMenorValor.TAM_IncPropuesto_Cash__c;
                            resumenPrecio.incentivoPropuesto = politicaMenorValor.TAM_IncPropuesto_Cash__c;
                            resumenPrecio.incentivoDealer = politicaMenorValor.TAM_IncDealer_Cash__c; 
                            resumenPrecio.incentivoTMEX =  politicaMenorValor.TAM_IncentivoTMEX_Cash__c;
                            resumenPrecio.periodoPolitica = string.valueOfGmt(politicaMenorValor.TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c);
                            resumenPrecio.bonoLealtad = politicaMenorValor.TAM_BonoLealtad__c;
                            resumenPrecio.bonoLealtadTMEX = politicaMenorValor.TAM_BonoLealtadTMEX__c;
                            resumenPrecio.bonoLealtadDealer = politicaMenorValor.TAM_BonoLealtadDealer__c;
                            resumenPrecio.pagoTFS = politicaMenorValor.TAM_Pago_TFS__c;
                            resumenPrecio.precioFinal = precioFinal;
                            resumenPrecio.idPolitica = politicaMenorValor.id;
                            listaIncentivos.add(resumenPrecio);
                        }
                        if(solicitaBono == 'ConBOno'){ 
                            decimal precioPublico =  precioVIN.PrecioPublico__c;
                            decimal bonoLealtad = politicaMenorValor.TAM_BonoLealtad__c != null ? politicaMenorValor.TAM_BonoLealtad__c : 0 ;
                            decimal bonoLealtadTMEX = politicaMenorValor.TAM_BonoLealtadTMEX__c != null ? politicaMenorValor.TAM_BonoLealtadTMEX__c : 0 ;
                            decimal bonoLealtadDealer  = politicaMenorValor.TAM_BonoLealtadDealer__c != null ? politicaMenorValor.TAM_BonoLealtadDealer__c : 0 ;
                            decimal precioFinal = precioPublico - politicaMenorValor.TAM_IncPropuesto_Cash__c - bonoLealtad;
                            wrapResumenPrecio resumenPrecio = new wrapResumenPrecio();
                            resumenPrecio.listaPrecioVigente = precioVIN.Pricebook2.Name;
                            resumenPrecio.nombrePolitica = politicaMenorValor.TAM_PoliticaIncentivos__R.Name;
                            resumenPrecio.precioPublico = precioVIN.PrecioPublico__c;
                            resumenPrecio.precioDealer =  precioVIN.PrecioPublico__c;
                            resumenPrecio.incentivoSeleccionado = politicaMenorValor.TAM_IncPropuesto_Cash__c;
                            resumenPrecio.incentivoPropuesto = politicaMenorValor.TAM_IncPropuesto_Cash__c;
                            resumenPrecio.incentivoDealer = politicaMenorValor.TAM_IncDealer_Cash__c; 
                            resumenPrecio.incentivoTMEX =  politicaMenorValor.TAM_IncentivoTMEX_Cash__c;
                            resumenPrecio.periodoPolitica = string.valueOfGmt(politicaMenorValor.TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c);
                            resumenPrecio.bonoLealtad = bonoLealtad;
                            resumenPrecio.bonoLealtadTMEX = bonoLealtadTMEX;
                            resumenPrecio.bonoLealtadDealer = bonoLealtadDealer;
                            resumenPrecio.pagoTFS = politicaMenorValor.TAM_Pago_TFS__c;
                            resumenPrecio.precioFinal = precioFinal;
                            resumenPrecio.idPolitica = politicaMenorValor.id;
                            listaIncentivos.add(resumenPrecio);
                        }    
                    //}
                }
            }
        }
        
        if(!listaIncentivos.isEmpty()){
            system.debug('entro lista llena');
            return listaIncentivos;
            
        }else{
            system.debug('lista vacia');
            return listaIncentivos;
        }   
        
        
    }   
    
    
    
    
    @AuraEnabled
    public static List<wrapResumenPrecio> getPoliticasVigentes(String modelo, String anioModelo,Date fechaVentaVIN,String solicitaBono,String tipoVenta){
        boolean pagoTFS;
        if(tipoVenta == 'TFS'){ 
            pagoTFS = true;
        }
        if(tipoVenta == 'SINTFS'){
            pagoTFS = false; 
        }
        
        List<PricebookEntry> precioVehiculo = new List<PricebookEntry>();
         TAM_DetallePoliticaJunction__c politicaMenorValor = new TAM_DetallePoliticaJunction__c();
        List<wrapResumenPrecio> listaIncentivos = new List<wrapResumenPrecio> ();
        TAM_DetallePoliticaJunction__c [] detallePoliticaInc;
        Pricebook2[] listaPrecio;
        integer getYear = fechaVentaVIN.year();
        integer getMonth =  fechaVentaVIN.month();
        integer getDay  = fechaVentaVIN.day();
        integer getDaysOfMonth = Date.daysInMonth(getYear,getMonth);   
        Date inicioMes = fechaVentaVIN.addDays(-getDay+1);  
        Date finMes = inicioMes.addDays(getDaysOfMonth-1); 
        String codigoProducto = modelo+anioModelo;       
        String nombreListaPrecio;
        
        Map<Integer, String> mapMes = new Map<Integer, String>();
        mapMes.put(1, 'Enero');
        mapMes.put(2, 'Febrero');
        mapMes.put(3, 'Marzo');
        mapMes.put(4, 'Abril');
        mapMes.put(5, 'Mayo');
        mapMes.put(6, 'Junio');
        mapMes.put(7, 'Julio');
        mapMes.put(8, 'Agosto');
        mapMes.put(9, 'Septiembre');
        mapMes.put(10, 'Octubre');
        mapMes.put(11, 'Noviembre');
        mapMes.put(12, 'Diciembre');
        
        Date todayDate = system.today();
        String mes = mapMes.get(getMonth);
        String nombreListaPreciosHoy = 'VH-'+mes+'-'+getYear;
        
        //Consultar el registro del detalle de la politica de incentivos a partir de ID  de registro
        detallePoliticaInc = [SELECT TAM_BonoLealtadDealer__c,TAM_BonoLealtadTMEX__c,TAM_Pago_TFS__c,TAM_PoliticaIncentivos__R.Name,TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c,TAM_BonoLealtad__c,name,TAM_IncentivoTMEX_Cash__c,TAM_IncPropuesto_Cash__c,TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c,
                              id,TAM_AnioModelo__c,TAM_Clave__c,TAM_IncDealer_Cash__c FROM TAM_DetallePoliticaJunction__c 
                              WHERE TAM_PoliticaIncentivos__R.recordtype.name = 'Retail' AND (TAM_PoliticaIncentivos__R.TAM_InicioVigencia__c <=: fechaVentaVIN AND TAM_PoliticaIncentivos__R.TAM_FinVigencia__c >=: fechaVentaVIN) AND TAM_Clave__c =: modelo AND TAM_AnioModelo__c =: anioModelo AND (TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vigente' or TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vencida')  order by TAM_IncPropuesto_Cash__c asc];
        
        system.debug('politica de venta'+detallePoliticaInc);

        Decimal maxvalue ;
        if(detallePoliticaInc.size() > 0){
         maxvalue = detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;   
        }
                    
        //Se calcula cual es la política con menor valor
        if(!detallePoliticaInc.isEmpty()){
        	For (TAM_DetallePoliticaJunction__c i : detallePoliticaInc)
        {
            
            if(i.TAM_IncPropuesto_Cash__c < maxvalue)
                maxvalue = i.TAM_IncPropuesto_Cash__c;   
                politicaMenorValor = i;
                break;
        	} 
        }
        
        //Consultar lista de precios *** Actualizar por la variable nombreListaPreciosHoy*****
        listaPrecio = [Select id,name from Pricebook2 where name =: nombreListaPreciosHoy];
        
        //Consultar el precio del Vehiculo en base a la lista de precos del dia de hoy  
        if(listaPrecio.size() >0){
        	precioVehiculo = [select id,name,PrecioDealer__c,Pricebook2.Name,PrecioMayorista__c,PrecioPublico__c,Product2.ProductCode,Product2.Anio__c From PricebookEntry WHERE Pricebook2Id =: listaPrecio[0].id AND Product2.IdExternoProducto__c =: codigoProducto];  
        }
        system.debug('precioresultado'+precioVehiculo);

        //Si el precio no existe en la lista de precios vigente se consulta el ultimo precio vigente del VIN
        if(precioVehiculo.isEmpty() || precioVehiculo == null ){
       						 precioVehiculo = [select Pricebook2.FinVigencia__c,id,PrecioDealer__c,Pricebook2.Name,PrecioMayorista__c,PrecioPublico__c
                              ,Product2.ProductCode,Product2.Anio__c From PricebookEntry 
                              WHERE  Product2.IdExternoProducto__c =: codigoProducto AND IsActive = true AND PrecioPublico__c != NULL order by Pricebook2.FinVigencia__c desc limit 1];  
            
            
        }
        
        if(precioVehiculo.size()> 0 && detallePoliticaInc.size() > 0){
            system.debug('entro a linea 488');
            //for(TAM_DetallePoliticaJunction__c incentivo: detallePoliticaInc){
                for(PricebookEntry precioVIN : precioVehiculo){
                    if(politicaMenorValor.TAM_IncPropuesto_Cash__c != null){

                        if(solicitaBono == 'SinBOno'){ 
                            decimal precioPublico = precioVIN.PrecioPublico__c;
                            decimal precioFinal = precioPublico - politicaMenorValor.TAM_IncPropuesto_Cash__c;
                            wrapResumenPrecio resumenPrecio = new wrapResumenPrecio();
                            resumenPrecio.listaPrecioVigente = precioVIN.Pricebook2.Name;
                            resumenPrecio.nombrePolitica = politicaMenorValor.TAM_PoliticaIncentivos__R.Name;
                            resumenPrecio.precioPublico = precioVIN.PrecioPublico__c;
                            resumenPrecio.precioDealer =  precioVIN.PrecioPublico__c;
                            resumenPrecio.incentivoSeleccionado = politicaMenorValor.TAM_IncPropuesto_Cash__c;
                            resumenPrecio.incentivoPropuesto = politicaMenorValor.TAM_IncPropuesto_Cash__c;
                            resumenPrecio.incentivoDealer = politicaMenorValor.TAM_IncDealer_Cash__c; 
                            resumenPrecio.incentivoTMEX =  politicaMenorValor.TAM_IncentivoTMEX_Cash__c;
                            resumenPrecio.periodoPolitica = string.valueOfGmt(politicaMenorValor.TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c);
                            resumenPrecio.bonoLealtad = politicaMenorValor.TAM_BonoLealtad__c;
                            resumenPrecio.bonoLealtadTMEX = politicaMenorValor.TAM_BonoLealtadTMEX__c;
                            resumenPrecio.bonoLealtadDealer = politicaMenorValor.TAM_BonoLealtadDealer__c;
                            resumenPrecio.pagoTFS = politicaMenorValor.TAM_Pago_TFS__c;
                            resumenPrecio.precioFinal = precioFinal;
                            resumenPrecio.idPolitica = politicaMenorValor.id;
                            listaIncentivos.add(resumenPrecio);
                        }
                        if(solicitaBono == 'ConBOno'){ 
                            decimal precioPublico =  precioVIN.PrecioPublico__c;
                            decimal bonoLealtad = politicaMenorValor.TAM_BonoLealtad__c != null ? politicaMenorValor.TAM_BonoLealtad__c : 0 ;
                            decimal bonoLealtadTMEX = politicaMenorValor.TAM_BonoLealtadTMEX__c != null ? politicaMenorValor.TAM_BonoLealtadTMEX__c : 0 ;
                            decimal bonoLealtadDealer  = politicaMenorValor.TAM_BonoLealtadDealer__c != null ? politicaMenorValor.TAM_BonoLealtadDealer__c : 0 ;
                            decimal precioFinal = precioPublico - politicaMenorValor.TAM_IncPropuesto_Cash__c - bonoLealtad;
                            wrapResumenPrecio resumenPrecio = new wrapResumenPrecio();
                            resumenPrecio.listaPrecioVigente = precioVIN.Pricebook2.Name;
                            resumenPrecio.nombrePolitica = politicaMenorValor.TAM_PoliticaIncentivos__R.Name;
                            resumenPrecio.precioPublico = precioVIN.PrecioPublico__c;
                            resumenPrecio.precioDealer =  precioVIN.PrecioPublico__c;
                            resumenPrecio.incentivoSeleccionado = politicaMenorValor.TAM_IncPropuesto_Cash__c;
                            resumenPrecio.incentivoPropuesto = politicaMenorValor.TAM_IncPropuesto_Cash__c;
                            resumenPrecio.incentivoDealer = politicaMenorValor.TAM_IncDealer_Cash__c; 
                            resumenPrecio.incentivoTMEX =  politicaMenorValor.TAM_IncentivoTMEX_Cash__c;
                            resumenPrecio.periodoPolitica = string.valueOfGmt(politicaMenorValor.TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c);
                            resumenPrecio.bonoLealtad = bonoLealtad;
                            resumenPrecio.bonoLealtadTMEX = bonoLealtadTMEX;
                            resumenPrecio.bonoLealtadDealer = bonoLealtadDealer;
                            resumenPrecio.pagoTFS = politicaMenorValor.TAM_Pago_TFS__c;
                            resumenPrecio.precioFinal = precioFinal;
                            resumenPrecio.idPolitica = politicaMenorValor.id;
                            listaIncentivos.add(resumenPrecio);
                        }    
                    //}
                }
            }
        }
        
        if(!listaIncentivos.isEmpty()){
            system.debug('Con politica de venta'+listaIncentivos);
            return listaIncentivos;
            
        }else{
            system.debug('Sin politica de venta'+listaIncentivos);
            return listaIncentivos;
        }   
        
    }   
    
    @AuraEnabled
    public static List<TAM_DetallePoliticaJunction__c> getPoliticasVIN(String modelNumber, String modelYear){
        Date fechaHoy = system.today();
        Date fechaMenos2Meses = date.today().adddays(-90);
        List<TAM_DetallePoliticaJunction__c> politicaVigenteObj = new List<TAM_DetallePoliticaJunction__c>();
        List<TAM_DetallePoliticaJunction__c>politicaVigente = new List<TAM_DetallePoliticaJunction__c>();       
        politicaVigente = [SELECT name,TAM_BonoLealtadTMEX__c,TAM_BonoLealtadDealer__c,TAM_Pago_TFS__c,TAM_PoliticaIncentivos__R.Name,TAM_BonoLealtad__c,TAM_PoliticaIncentivos__R.CreatedDate,TAM_IncPropuesto_Cash__c,TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c,TAM_IncentivoTMEX_Cash__c,TAM_IncTFS_Cash__c,TAM_TP_IncDealer_Cash__c,TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c,
                           id,TAM_AnioModelo__c,TAM_Clave__c,TAM_IncDealer_Cash__c FROM TAM_DetallePoliticaJunction__c 
                           WHERE TAM_IncPropuesto_Cash__c != null AND  TAM_PoliticaIncentivos__R.recordtype.name = 'Retail' AND (TAM_PoliticaIncentivos__R.TAM_InicioVigencia__c >=: fechaMenos2Meses or TAM_PoliticaIncentivos__R.TAM_FinVigencia__c >=: fechaMenos2Meses ) AND TAM_PoliticaIncentivos__R.recordtype.name = 'Retail' AND TAM_Clave__c =: modelNumber AND TAM_AnioModelo__c =: modelYear AND
                           (TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vigente' or TAM_PoliticaIncentivos__R.TAM_EstatusIncentivos__c = 'Vencida') order by TAM_PoliticaIncentivos__R.TAM_InicioVigencia__c desc];
         
        
        if (!politicaVigente.isEmpty()) {
            return politicaVigente;
        }else{
            return politicaVigenteObj;
            
        }	
        
    }
    
    
    @AuraEnabled
    public static Id registraSolicitudExcepcion(String vin, String serie, Integer incentivoVigente, Integer incentivoPropuesto, String comentario,String motivoSelect,String politicaSeleccionada,String dealerId,List<wrapResumenPrecio> politicasCorrespondientes,String tipoVenta,String tipoRegistro,DateTime fechaVentaVIN,String anioModelo,String modelo,String version,Boolean aprobacionAutomatica){        
        String tipoDeVenta;
        String recordTypeId;
        if(tipoVenta == 'TFS'){
			tipoDeVenta = 'Con TFS';            
        }
        if(tipoVenta == 'SINTFS'){
			tipoDeVenta = 'Sin TFS';            
        }
        
        if(tipoRegistro == 'Retail'){
        	recordTypeId =  Schema.SObjectType.TAM_SolicitudExpecionIncentivo__c.getRecordTypeInfosByDeveloperName().get('Cambio_de_Incentivo').getRecordTypeId();    
        } 
        
        if(tipoRegistro == 'AutoDemo'){
        	recordTypeId =  Schema.SObjectType.TAM_SolicitudExpecionIncentivo__c.getRecordTypeInfosByDeveloperName().get('Auto_Demo').getRecordTypeId();    
        } 
       
       TAM_SolicitudExpecionIncentivo__c solicitudExepcion = new TAM_SolicitudExpecionIncentivo__c();
       if(!politicasCorrespondientes.isEmpty()){
            for(wrapResumenPrecio politicasCorres : politicasCorrespondientes){
                solicitudExepcion.TAMVIN__c = vin;
                solicitudExepcion.TAM_Serie__c = serie;
                solicitudExepcion.TAM_AnioModelo__c = anioModelo;
                solicitudExepcion.TAM_Modelo__c = modelo;
                solicitudExepcion.TAM_VersionVIN__c = version; 
                solicitudExepcion.TAM_SubmittedDate__c = fechaVentaVIN.date();
                solicitudExepcion.TAM_Comentario__c = Comentario;
                //No se necesita autorizacion
                if(aprobacionAutomatica == true){
                    solicitudExepcion.TAM_AprobacionDM__c = 'Aprobado';
                    solicitudExepcion.TAM_AprobacionFinanzas__c = 'Aprobado';
                    solicitudExepcion.TAM_Fecha_Autorizacion_DM__c = Date.today();
                    solicitudExepcion.TAM_AprobacionAutomatica__c = true;
                }
                //Se necesita autorizacion
                if(aprobacionAutomatica == false){
                    solicitudExepcion.TAM_AprobacionDM__c = 'Pendiente';
                    solicitudExepcion.TAM_AprobacionFinanzas__c = 'Pendiente';   
                    solicitudExepcion.TAM_AprobacionAutomatica__c = false;
                }
                solicitudExepcion.TAM_MotivoSolicitud__c = motivoSelect;
                solicitudExepcion.TAM_PoliticaSeleccionadaRetail__c = politicaSeleccionada;
                solicitudExepcion.TAM_Distribuidor__c = dealerId;
                solicitudExepcion.TAM_TipoVenta__c = tipoDeVenta;
                solicitudExepcion.recordtypeid = recordTypeId;
				solicitudExepcion.TAM_IncentivoCorrespondienteRetail__c = politicasCorres.idPolitica; 
                    
                
            }
        }
        
        //VIN sin incentivo de fecha vigente
        if(politicasCorrespondientes.isEmpty()){
        		solicitudExepcion.TAMVIN__c = vin;
                solicitudExepcion.TAM_Serie__c = serie;
                solicitudExepcion.TAM_AnioModelo__c = anioModelo;
                solicitudExepcion.TAM_Modelo__c = modelo;
                solicitudExepcion.TAM_VersionVIN__c = version;
            	solicitudExepcion.TAM_SubmittedDate__c = fechaVentaVIN.date();
                solicitudExepcion.TAM_Comentario__c = Comentario;
                 //No se necesita autorizacion
                 if(aprobacionAutomatica == true){
                    solicitudExepcion.TAM_AprobacionDM__c = 'Aprobado';
                    solicitudExepcion.TAM_AprobacionFinanzas__c = 'Aprobado';
                    solicitudExepcion.TAM_Fecha_Autorizacion_DM__c = Date.today();
                    solicitudExepcion.TAM_AprobacionAutomatica__c = true;
                }
                //Se necesita autorizacion
                if(aprobacionAutomatica == false){
                    solicitudExepcion.TAM_AprobacionDM__c = 'Pendiente';
                    solicitudExepcion.TAM_AprobacionFinanzas__c = 'Pendiente';   
                    solicitudExepcion.TAM_AprobacionAutomatica__c = false;
                }
                solicitudExepcion.TAM_MotivoSolicitud__c = motivoSelect;
                solicitudExepcion.TAM_PoliticaSeleccionadaRetail__c = politicaSeleccionada;
                solicitudExepcion.TAM_Distribuidor__c = dealerId;
                solicitudExepcion.TAM_TipoVenta__c = tipoDeVenta;
                solicitudExepcion.recordtypeid = recordTypeId;
            
        }
        try{
            system.debug('Registro a Insertar'+solicitudExepcion);
            insert solicitudExepcion;
            
        }catch(Exception e){
            system.debug('Error general al insertar la solicitud de exepeción'+e.getMessage());
            
        }
        
        return solicitudExepcion.id;    
        
    }
    
    @AuraEnabled
    public static wrapResumenPrecio calculoPrecioIncentico(String idPoliticaIncentivo,String modelo,String anioModelo,String solicitaBono){
        PricebookEntry[] precioVehiculo;
        Pricebook2[] listaPrecio;
        wrapResumenPrecio resumenPrecio = new wrapResumenPrecio();
        TAM_DetallePoliticaJunction__c [] detallePoliticaInc;
        String codigoProducto = modelo+anioModelo;       
        
        Map<Integer, String> mapMes = new Map<Integer, String>();
        mapMes.put(1, 'Enero');
        mapMes.put(2, 'Febrero');
        mapMes.put(3, 'Marzo');
        mapMes.put(4, 'Abril');
        mapMes.put(5, 'Mayo');
        mapMes.put(6, 'Junio');
        mapMes.put(7, 'Julio');
        mapMes.put(8, 'Agosto');
        mapMes.put(9, 'Septiembre');
        mapMes.put(10, 'Octubre');
        mapMes.put(11, 'Noviembre');
        mapMes.put(12, 'Diciembre');
        
        String nombreListaPrecio;
        Date todayDate = system.today();
        integer todayMonth =  todayDate.month();
        integer todayYear =  todayDate.year();
        String mes = mapMes.get(todayMonth);
        String nombreListaPreciosVigente = 'VH-'+mes+'-'+todayYear;
        
        
        //Consultar el registro del detalle de la politica de incentivos a partir de ID  de registro
        detallePoliticaInc = [Select id,TAM_BonoLealtadTMEX__c,TAM_BonoLealtadDealer__c,TAM_PoliticaIncentivos__R.Name,TAM_Pago_TFS__c,TAM_BonoLealtad__c,name,TAM_IncentivoTMEX_Cash__c,TAM_IncPropuesto_Cash__c,TAM_IncDealer_Cash__c,TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c FROM TAM_DetallePoliticaJunction__c WHERE Id =: idPoliticaIncentivo];
        
        
        //Consultar lista de precios *** Actualizar por la variable nombreListaPreciosHoy*****
        listaPrecio = [Select id,name from Pricebook2 where name =: nombreListaPreciosVigente];
        
        //Consultar el precio mas actual del Vehiculo
        precioVehiculo = [select Pricebook2.FinVigencia__c,id,PrecioDealer__c,Pricebook2.Name,PrecioMayorista__c,PrecioPublico__c
                          ,Product2.ProductCode,Product2.Anio__c From PricebookEntry 
                          WHERE  Product2.IdExternoProducto__c =: codigoProducto AND IsActive = true AND PrecioPublico__c != NULL AND Pricebook2.Name != 'Standard Price Book' order by Pricebook2.FinVigencia__c desc limit 1];
        
        if(solicitaBono == 'SinBOno' && precioVehiculo.size()>0 && detallePoliticaInc.size()>0){        
            decimal precioPublico = precioVehiculo[0].PrecioPublico__c;
            decimal precioFinal = precioPublico - detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;
            resumenPrecio.listaPrecioVigente = precioVehiculo[0].Pricebook2.Name;
            resumenPrecio.nombrePolitica = detallePoliticaInc[0].TAM_PoliticaIncentivos__R.Name;
            resumenPrecio.precioPublico =precioVehiculo[0].PrecioPublico__c;
            resumenPrecio.precioDealer = precioVehiculo[0].PrecioPublico__c;
            resumenPrecio.incentivoSeleccionado = detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;
            resumenPrecio.incentivoPropuesto = detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;
            resumenPrecio.incentivoDealer = detallePoliticaInc[0].TAM_IncDealer_Cash__c; 
            resumenPrecio.incentivoTMEX =  detallePoliticaInc[0].TAM_IncentivoTMEX_Cash__c;
            resumenPrecio.periodoPolitica =  string.valueOfGmt(detallePoliticaInc[0].TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c); 
            resumenPrecio.bonoLealtad = detallePoliticaInc[0].TAM_BonoLealtad__c;
            resumenPrecio.bonoLealtadTMEX = detallePoliticaInc[0].TAM_BonoLealtadTMEX__c;
            resumenPrecio.bonoLealtadDealer = detallePoliticaInc[0].TAM_BonoLealtadDealer__c;
            resumenPrecio.pagoTFS = detallePoliticaInc[0].TAM_Pago_TFS__c;
            resumenPrecio.precioFinal = precioFinal;
        }
        
        if(solicitaBono == 'ConBono' && precioVehiculo.size()>0 && detallePoliticaInc.size()>0){        
            decimal precioPublico = precioVehiculo[0].PrecioPublico__c;
            decimal bonoLealtad = detallePoliticaInc[0].TAM_BonoLealtad__c != null ? detallePoliticaInc[0].TAM_BonoLealtad__c : 0 ;
            decimal bonoLealtadTMEX = detallePoliticaInc[0].TAM_BonoLealtadTMEX__c != null ? detallePoliticaInc[0].TAM_BonoLealtadTMEX__c : 0 ;
            decimal bonoLealtadDealer  = detallePoliticaInc[0].TAM_BonoLealtadDealer__c != null ? detallePoliticaInc[0].TAM_BonoLealtadDealer__c : 0 ;
            decimal precioFinal = precioPublico - detallePoliticaInc[0].TAM_IncPropuesto_Cash__c -bonoLealtad;
            resumenPrecio.listaPrecioVigente = precioVehiculo[0].Pricebook2.Name;
            resumenPrecio.nombrePolitica = detallePoliticaInc[0].TAM_PoliticaIncentivos__R.Name;
            resumenPrecio.precioPublico =precioVehiculo[0].PrecioPublico__c;
            resumenPrecio.precioDealer = precioVehiculo[0].PrecioPublico__c;
            resumenPrecio.incentivoSeleccionado = detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;
            resumenPrecio.incentivoPropuesto = detallePoliticaInc[0].TAM_IncPropuesto_Cash__c;
            resumenPrecio.incentivoDealer = detallePoliticaInc[0].TAM_IncDealer_Cash__c; 
            resumenPrecio.incentivoTMEX =  detallePoliticaInc[0].TAM_IncentivoTMEX_Cash__c;
            resumenPrecio.periodoPolitica =  string.valueOfGmt(detallePoliticaInc[0].TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c);
            resumenPrecio.pagoTFS = detallePoliticaInc[0].TAM_Pago_TFS__c;
            resumenPrecio.bonoLealtad = bonoLealtad;
            resumenPrecio.bonoLealtadTMEX = bonoLealtadTMEX;
            resumenPrecio.bonoLealtadDealer = bonoLealtadDealer;
            resumenPrecio.precioFinal = precioFinal;
        }

        return resumenPrecio;
        
    } 
    
    @AuraEnabled
    public static List<String> obtieneMotivosSolicitud(){
        List<String> pickListValuesList= new List<String>();
        Schema.DescribeFieldResult fieldResult = TAM_SolicitudExpecionIncentivo__c.TAM_MotivoSolicitud__c.getDescribe();
        List<Schema.PicklistEntry> ple = fieldResult.getPicklistValues();
        for( Schema.PicklistEntry pickListVal : ple){
            pickListValuesList.add(pickListVal.getLabel());
        }   
         
        return pickListValuesList;
        
    }
    
    @AuraEnabled
    public static List<TAM_DetalleEstadoCuenta__c> buscaFacturasVIN(String VIN){
        List<TAM_DetalleEstadoCuenta__c> pagoIncentivosObj = new List<TAM_DetalleEstadoCuenta__c> ();
        List<TAM_DetalleEstadoCuenta__c> pagoIncentivos    = [Select id,TAM_EstatusVINEdoCta__c,TAM_FolioFactura__c,name,TAM_VIN__c,TAM_CodigoDealer__c,TAM_Fecha_Pago__c,TAM_Estatus_Finanzas__c FROM TAM_DetalleEstadoCuenta__c WHERE TAM_VIN__c =: VIN AND (TAM_Estatus_Finanzas__c = 'Pago Autorizado TMEX' OR TAM_EstatusVINEdoCta__c = 'Enviado a Facturar')];
        
        if(!pagoIncentivos.isEmpty()){
            return pagoIncentivos;
            
        }else{
            return pagoIncentivosObj;
            
        }
        
        
    }
    
    @AuraEnabled
    public static List<TAM_SolicitudExpecionIncentivo__c> buscaExcepcionesSFDC(String VIN){
        List<TAM_SolicitudExpecionIncentivo__c> solicitudExcepcionesObj = new List<TAM_SolicitudExpecionIncentivo__c> ();
        List<TAM_SolicitudExpecionIncentivo__c> solicitudExcepciones = new List<TAM_SolicitudExpecionIncentivo__c>();

        //Recordtype excepción de retail
        String recordIdSolicitudRetail = Schema.SObjectType.TAM_SolicitudExpecionIncentivo__c.getRecordTypeInfosByDeveloperName().get('Cambio_de_Incentivo').getRecordTypeId();

        //Recordtype excepción de AutoDemo
        Id recordtypeDemo = Schema.SObjectType.TAM_SolicitudExpecionIncentivo__c.getRecordTypeInfosByDeveloperName().get('Auto_Demo').getRecordTypeId();


        solicitudExcepciones = [Select id,name from TAM_SolicitudExpecionIncentivo__c 
                                    WHERE TAMVIN__c =: VIN AND recordtypeId =: recordIdSolicitudRetail
                                    AND (TAM_AprobacionDM__c = 'Pendiente' or TAM_AprobacionDM__c = 'Aprobado')
                                   AND  (TAM_AprobacionFinanzas__c = 'Pendiente' or TAM_AprobacionFinanzas__c = 'Aprobado') 
                                   ];

        if(!solicitudExcepciones.isEmpty()){
            return solicitudExcepciones;                               
        }else{
            return solicitudExcepcionesObj;
                                        
        } 

    }

    @AuraEnabled
    public static void relatedDocumentWithRequestException (String idSolicitudCreada, String idDocumento){
        ContentDocumentLink cdl = New ContentDocumentLink();
        cdl.LinkedEntityId = idSolicitudCreada;
        cdl.ContentDocumentId = idDocumento;
        cdl.shareType = 'v';
        cdl.Visibility = 'AllUsers';

        try{
            Insert cdl;
        }Catch(Exception e){
            System.debug('Error al relacionar documento con la solicitud');

        }

    }   

    @AuraEnabled
    public static void deleteDocument (String documentId){
        ContentDocument[] documentRecord;
        documentRecord = [Select id from ContentDocument WHERE id =: documentId];
        if(documentRecord.size() >0){
            delete documentRecord[0];   
        }
        
    }   
    
    @AuraEnabled
    public static void relatedDocumentWithException(List<String> listaSolicitud,String documentId){        
        List<ContentDocumentLink> documentLink = new List<ContentDocumentLink>();
        if(!listaSolicitud.isEmpty()){
            for(String solicitudId : listaSolicitud){
                ContentDocumentLink cdl = New ContentDocumentLink();
                cdl.LinkedEntityId = solicitudId;
                cdl.ContentDocumentId = documentId;
                cdl.shareType = 'v';
                cdl.Visibility = 'AllUsers';
                documentLink.add(cdl);
            }
        }

        try {
            if(!documentLink.isEmpty()){
                system.debug('Lista a insertar'+documentLink);
                insert documentLink;    
    
            }
            
        } catch (Exception e) {
            system.debug('Error general'+e.getMessage());
        }
    }



    public class wrapResumenPrecio {
        @AuraEnabled public decimal precioPublico {get; set;}
        @AuraEnabled public decimal precioDealer {get; set;}
        @AuraEnabled public decimal incentivoSeleccionado {get; set;}
        @AuraEnabled public decimal precioFinal {get; set;}
        @AuraEnabled public decimal incentivoPropuesto {get; set;}
        @AuraEnabled public decimal incentivoDealer {get; set;}
        @AuraEnabled public decimal incentivoTMEX {get; set;}
        @AuraEnabled public decimal bonoLealtad {get; set;}
        @AuraEnabled public decimal bonoLealtadTMEX {get; set;}
        @AuraEnabled public decimal bonoLealtadDealer {get; set;}
        @AuraEnabled public String nombrePolitica {get; set;}
        @AuraEnabled public String periodoPolitica {get; set;}
        @AuraEnabled public String listaPrecioVigente {get; set;}
        @AuraEnabled public Boolean pagoTFS {get; set;}
        @AuraEnabled public String idPolitica {get; set;}
    }
}